maint.mk: don't maintain a second build-aux variable.
[gnulib.git] / top / maint.mk
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
4
5 ## Copyright (C) 2001-2011 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
23
24 # Diagnostic for continued use of deprecated variable.
25 # Remove in 2013
26 ifneq ($(build_aux),)
27  $(error "$(ME): \
28 set $$(_build-aux) relative to $$(srcdir) instead of $$(build_aux)")
29 endif
30
31 # Do not save the original name or timestamp in the .tar.gz file.
32 # Use --rsyncable if available.
33 gzip_rsyncable := \
34   $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
35     && printf %s --rsyncable)
36 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
37
38 GIT = git
39 VC = $(GIT)
40
41 VC_LIST = $(srcdir)/$(_build-aux)/vc-list-files -C $(srcdir)
42
43 # You can override this variable in cfg.mk to set your own regexp
44 # matching files to ignore.
45 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
46
47 # This is to preprocess robustly the output of $(VC_LIST), so that even
48 # when $(srcdir) is a pathological name like "....", the leading sed command
49 # removes only the intended prefix.
50 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
51
52 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
53 # when $(srcdir) is not ".".
54 ifeq ($(srcdir),.)
55 _prepend_srcdir_prefix =
56 else
57 _prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
58 endif
59
60 # In order to be able to consistently filter "."-relative names,
61 # (i.e., with no $(srcdir) prefix), this definition is careful to
62 # remove any $(srcdir) prefix, and to restore what it removes.
63 _sc_excl = \
64   $(if $(exclude_file_name_regexp--$@),$(exclude_file_name_regexp--$@),^$$)
65 VC_LIST_EXCEPT = \
66   $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
67         | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
68           else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
69         | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
70         $(_prepend_srcdir_prefix)
71
72 ifeq ($(origin prev_version_file), undefined)
73   prev_version_file = $(srcdir)/.prev-version
74 endif
75
76 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
77 VERSION_REGEXP = $(subst .,\.,$(VERSION))
78 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
79
80 ifeq ($(VC),$(GIT))
81 this-vc-tag = v$(VERSION)
82 this-vc-tag-regexp = v$(VERSION_REGEXP)
83 else
84 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
85 tag-this-version = $(subst .,_,$(VERSION))
86 this-vc-tag = $(tag-package)-$(tag-this-version)
87 this-vc-tag-regexp = $(this-vc-tag)
88 endif
89 my_distdir = $(PACKAGE)-$(VERSION)
90
91 # Old releases are stored here.
92 release_archive_dir ?= ../release
93
94 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
95 # Use alpha.gnu.org for alpha and beta releases.
96 # Use ftp.gnu.org for stable releases.
97 gnu_ftp_host-alpha = alpha.gnu.org
98 gnu_ftp_host-beta = alpha.gnu.org
99 gnu_ftp_host-stable = ftp.gnu.org
100 gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
101
102 ifeq ($(gnu_rel_host),ftp.gnu.org)
103 url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
104 else
105 url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
106 endif
107
108 # Override this in cfg.mk if you are using a different format in your
109 # NEWS file.
110 today = $(shell date +%Y-%m-%d)
111
112 # Select which lines of NEWS are searched for $(news-check-regexp).
113 # This is a sed line number spec.  The default says that we search
114 # lines 1..10 of NEWS for $(news-check-regexp).
115 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
116 news-check-lines-spec ?= 1,10
117 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
118
119 # Prevent programs like 'sort' from considering distinct strings to be equal.
120 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
121 export LC_ALL = C
122
123 ## --------------- ##
124 ## Sanity checks.  ##
125 ## --------------- ##
126
127 _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
128
129 # Collect the names of rules starting with `sc_'.
130 syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
131                         $(srcdir)/$(ME) $(_cfg_mk)))
132 .PHONY: $(syntax-check-rules)
133
134 ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
135 local-checks-available += $(syntax-check-rules)
136 else
137 local-checks-available += no-vc-detected
138 no-vc-detected:
139         @echo "No version control files detected; skipping syntax check"
140 endif
141 .PHONY: $(local-checks-available)
142
143 # Arrange to print the name of each syntax-checking rule just before running it.
144 $(syntax-check-rules): %: %.m
145 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
146 .PHONY: $(sc_m_rules_)
147 $(sc_m_rules_):
148         @echo $(patsubst sc_%.m, %, $@)
149         @date +%s.%N > .sc-start-$(basename $@)
150
151 # Compute and print the elapsed time for each syntax-check rule.
152 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
153 .PHONY: $(sc_z_rules_)
154 $(sc_z_rules_): %.z: %
155         @end=$$(date +%s.%N);                                           \
156         start=$$(cat .sc-start-$*);                                     \
157         rm -f .sc-start-$*;                                             \
158         awk -v s=$$start -v e=$$end                                     \
159           'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
160
161 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
162 # that computes and prints elapsed time.
163 local-check :=                                                          \
164   $(patsubst sc_%, sc_%.z,                                              \
165     $(filter-out $(local-checks-to-skip), $(local-checks-available)))
166
167 syntax-check: $(local-check)
168
169 # _sc_search_regexp
170 #
171 # This macro searches for a given construct in the selected files and
172 # then takes some action.
173 #
174 # Parameters (shell variables):
175 #
176 #  prohibit | require
177 #
178 #     Regular expression (ERE) denoting either a forbidden construct
179 #     or a required construct.  Those arguments are exclusive.
180 #
181 #  in_vc_files | in_files
182 #
183 #     grep-E-style regexp denoting the files to check.  If no files
184 #     are specified the default are all the files that are under
185 #     version control.
186 #
187 #  containing | non_containing
188 #
189 #     Select the files (non) containing strings matching this regexp.
190 #     If both arguments are specified then CONTAINING takes
191 #     precedence.
192 #
193 #  with_grep_options
194 #
195 #     Extra options for grep.
196 #
197 #  ignore_case
198 #
199 #     Ignore case.
200 #
201 #  halt
202 #
203 #     Message to display before to halting execution.
204 #
205 # Finally, you may exempt files based on an ERE matching file names.
206 # For example, to exempt from the sc_space_tab check all files with the
207 # .diff suffix, set this Make variable:
208 #
209 # exclude_file_name_regexp--sc_space_tab = \.diff$
210 #
211 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
212 # when filtering by name via in_files, we explicitly filter out matching
213 # names here as well.
214
215 # By default, _sc_search_regexp does not ignore case.
216 export ignore_case =
217 _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
218
219 define _sc_say_and_exit
220    dummy=; : so we do not need a semicolon before each use;             \
221    { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
222 endef
223
224 # _sc_search_regexp used to be named _prohibit_regexp.  However,
225 # upgrading to the new definition and leaving the old name undefined
226 # would usually convert each custom rule using $(_prohibit_regexp)
227 # (usually defined in cfg.mk) into a no-op.  This definition ensures
228 # that people know right away if they're still using the old name.
229 # FIXME: remove in 2012.
230 _prohibit_regexp = \
231   $(error '*** you need to s/_prohibit_regexp/_sc_search_regexp/, and adapt')
232
233 define _sc_search_regexp
234    dummy=; : so we do not need a semicolon before each use;             \
235                                                                         \
236    : Check arguments;                                                   \
237    test -n "$$prohibit" && test -n "$$require"                          \
238      && { msg='Cannot specify both prohibit and require'                \
239           $(_sc_say_and_exit) } || :;                                   \
240    test -z "$$prohibit" && test -z "$$require"                          \
241      && { msg='Should specify either prohibit or require'               \
242           $(_sc_say_and_exit) } || :;                                   \
243    test -n "$$in_vc_files" && test -n "$$in_files"                      \
244      && { msg='Cannot specify both in_vc_files and in_files'            \
245           $(_sc_say_and_exit) } || :;                                   \
246    test "x$$halt" != x                                                  \
247      || { msg='halt not defined' $(_sc_say_and_exit) };                 \
248                                                                         \
249    : Filter by file name;                                               \
250    if test -n "$$in_files"; then                                        \
251      files=$$(find $(srcdir) | grep -E "$$in_files"                     \
252               | grep -Ev '$(exclude_file_name_regexp--$@)');            \
253    else                                                                 \
254      files=$$($(VC_LIST_EXCEPT));                                       \
255      if test -n "$$in_vc_files"; then                                   \
256        files=$$(echo "$$files" | grep -E "$$in_vc_files");              \
257      fi;                                                                \
258    fi;                                                                  \
259                                                                         \
260    : Filter by content;                                                 \
261    test -n "$$files" && test -n "$$containing"                          \
262      && { files=$$(grep -l "$$containing" $$files); } || :;             \
263    test -n "$$files" && test -n "$$non_containing"                      \
264      && { files=$$(grep -vl "$$non_containing" $$files); } || :;        \
265                                                                         \
266    : Check for the construct;                                           \
267    if test -n "$$files"; then                                           \
268      if test -n "$$prohibit"; then                                      \
269        grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
270          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
271      else                                                               \
272        grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
273            | grep .                                                     \
274          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
275      fi                                                                 \
276    else :;                                                              \
277    fi || :;
278 endef
279
280 sc_avoid_if_before_free:
281         @$(srcdir)/$(_build-aux)/useless-if-before-free                 \
282                 $(useless_free_options)                                 \
283             $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) &&   \
284           { echo '$(ME): found useless "if" before "free" above' 1>&2;  \
285             exit 1; } || :
286
287 sc_cast_of_argument_to_free:
288         @prohibit='\<free *\( *\(' halt='don'\''t cast free argument'   \
289           $(_sc_search_regexp)
290
291 sc_cast_of_x_alloc_return_value:
292         @prohibit='\*\) *x(m|c|re)alloc\>'                              \
293         halt='don'\''t cast x*alloc return value'                       \
294           $(_sc_search_regexp)
295
296 sc_cast_of_alloca_return_value:
297         @prohibit='\*\) *alloca\>'                                      \
298         halt='don'\''t cast alloca return value'                        \
299           $(_sc_search_regexp)
300
301 sc_space_tab:
302         @prohibit='[ ]  '                                               \
303         halt='found SPACE-TAB sequence; remove the SPACE'               \
304           $(_sc_search_regexp)
305
306 # Don't use *scanf or the old ato* functions in `real' code.
307 # They provide no error checking mechanism.
308 # Instead, use strto* functions.
309 sc_prohibit_atoi_atof:
310         @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\('                           \
311         halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q'   \
312           $(_sc_search_regexp)
313
314 # Use STREQ rather than comparing strcmp == 0, or != 0.
315 sc_prohibit_strcmp:
316         @grep -nE '! *str''cmp *\(|\<str''cmp *\(.+\) *[!=]='   \
317             $$($(VC_LIST_EXCEPT))                                       \
318           | grep -vE ':# *define STRN?EQ\(' &&                          \
319           { echo '$(ME): replace str''cmp calls above with STREQ/STRNEQ' \
320                 1>&2; exit 1; } || :
321
322 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
323 # Convert all uses automatically, via these two commands:
324 # git grep -l '\<exit *(1)' \
325 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
326 #  | xargs --no-run-if-empty \
327 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
328 # git grep -l '\<exit *(0)' \
329 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
330 #  | xargs --no-run-if-empty \
331 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
332 sc_prohibit_magic_number_exit:
333         @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,'     \
334         halt='use EXIT_* values rather than magic number'                       \
335           $(_sc_search_regexp)
336
337 # Using EXIT_SUCCESS as the first argument to error is misleading,
338 # since when that parameter is 0, error does not exit.  Use `0' instead.
339 sc_error_exit_success:
340         @prohibit='error *\(EXIT_SUCCESS,'                              \
341         in_vc_files='\.[chly]$$'                                        \
342         halt='found error (EXIT_SUCCESS'                                \
343          $(_sc_search_regexp)
344
345 # `FATAL:' should be fully upper-cased in error messages
346 # `WARNING:' should be fully upper-cased, or fully lower-cased
347 sc_error_message_warn_fatal:
348         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
349             | grep -E '"Warning|"Fatal|"fatal' &&                       \
350           { echo '$(ME): use FATAL, WARNING or warning' 1>&2;           \
351             exit 1; } || :
352
353 # Error messages should not start with a capital letter
354 sc_error_message_uppercase:
355         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
356             | grep -E '"[A-Z]'                                          \
357             | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' &&           \
358           { echo '$(ME): found capitalized error message' 1>&2;         \
359             exit 1; } || :
360
361 # Error messages should not end with a period
362 sc_error_message_period:
363         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
364             | grep -E '[^."]\."' &&                                     \
365           { echo '$(ME): found error message ending in period' 1>&2;    \
366             exit 1; } || :
367
368 sc_file_system:
369         @prohibit=file''system                                          \
370         ignore_case=1                                                   \
371         halt='found use of "file''system"; spell it "file system"'      \
372           $(_sc_search_regexp)
373
374 # Don't use cpp tests of this symbol.  All code assumes config.h is included.
375 sc_prohibit_have_config_h:
376         @prohibit='^# *if.*HAVE''_CONFIG_H'                             \
377         halt='found use of HAVE''_CONFIG_H; remove'                     \
378           $(_sc_search_regexp)
379
380 # Nearly all .c files must include <config.h>.  However, we also permit this
381 # via inclusion of a package-specific header, if cfg.mk specified one.
382 # config_h_header must be suitable for grep -E.
383 config_h_header ?= <config\.h>
384 sc_require_config_h:
385         @require='^# *include $(config_h_header)'                       \
386         in_vc_files='\.c$$'                                             \
387         halt='the above files do not include <config.h>'                \
388           $(_sc_search_regexp)
389
390 # You must include <config.h> before including any other header file.
391 # This can possibly be via a package-specific header, if given by cfg.mk.
392 sc_require_config_h_first:
393         @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then       \
394           fail=0;                                                       \
395           for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do             \
396             grep '^# *include\>' $$i | sed 1q                           \
397                 | grep -E '^# *include $(config_h_header)' > /dev/null  \
398               || { echo $$i; fail=1; };                                 \
399           done;                                                         \
400           test $$fail = 1 &&                                            \
401             { echo '$(ME): the above files include some other header'   \
402                 'before <config.h>' 1>&2; exit 1; } || :;               \
403         else :;                                                         \
404         fi
405
406 sc_prohibit_HAVE_MBRTOWC:
407         @prohibit='\bHAVE_MBRTOWC\b'                                    \
408         halt="do not use $$prohibit; it is always defined"              \
409           $(_sc_search_regexp)
410
411 # To use this "command" macro, you must first define two shell variables:
412 # h: the header name, with no enclosing <> or ""
413 # re: a regular expression that matches IFF something provided by $h is used.
414 define _sc_header_without_use
415   dummy=; : so we do not need a semicolon before each use;              \
416   h_esc=`echo '[<"]'"$$h"'[">]'|sed 's/\./\\\\./g'`;                    \
417   if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then              \
418     files=$$(grep -l '^# *include '"$$h_esc"                            \
419              $$($(VC_LIST_EXCEPT) | grep '\.c$$')) &&                   \
420     grep -LE "$$re" $$files | grep . &&                                 \
421       { echo "$(ME): the above files include $$h but don't use it"      \
422         1>&2; exit 1; } || :;                                           \
423   else :;                                                               \
424   fi
425 endef
426
427 # Prohibit the inclusion of assert.h without an actual use of assert.
428 sc_prohibit_assert_without_use:
429         @h='assert.h' re='\<assert *\(' $(_sc_header_without_use)
430
431 # Prohibit the inclusion of close-stream.h without an actual use.
432 sc_prohibit_close_stream_without_use:
433         @h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)
434
435 # Prohibit the inclusion of getopt.h without an actual use.
436 sc_prohibit_getopt_without_use:
437         @h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
438
439 # Don't include quotearg.h unless you use one of its functions.
440 sc_prohibit_quotearg_without_use:
441         @h='quotearg.h' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
442
443 # Don't include quote.h unless you use one of its functions.
444 sc_prohibit_quote_without_use:
445         @h='quote.h' re='\<quote(_n)? *\(' $(_sc_header_without_use)
446
447 # Don't include this header unless you use one of its functions.
448 sc_prohibit_long_options_without_use:
449         @h='long-options.h' re='\<parse_long_options *\(' \
450           $(_sc_header_without_use)
451
452 # Don't include this header unless you use one of its functions.
453 sc_prohibit_inttostr_without_use:
454         @h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
455           $(_sc_header_without_use)
456
457 # Don't include this header unless you use one of its functions.
458 sc_prohibit_ignore_value_without_use:
459         @h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
460           $(_sc_header_without_use)
461
462 # Don't include this header unless you use one of its functions.
463 sc_prohibit_error_without_use:
464         @h='error.h' \
465         re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
466           $(_sc_header_without_use)
467
468 # Don't include xalloc.h unless you use one of its functions.
469 # Consider these symbols:
470 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
471 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
472 # Divide into two sets on case, and filter each through this:
473 # | sort | perl -MRegexp::Assemble -le \
474 #  'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
475 # Note this was produced by the above:
476 # _xa1 = \
477 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
478 # But we can do better, in at least two ways:
479 # 1) take advantage of two "dup"-suffixed strings:
480 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
481 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
482 # "char|[cmz]"
483 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
484 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
485 _xa2 = X([CZ]|N?M)ALLOC
486 sc_prohibit_xalloc_without_use:
487         @h='xalloc.h' \
488         re='\<($(_xa1)|$(_xa2)) *\('\
489           $(_sc_header_without_use)
490
491 # Extract function names:
492 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
493 _hash_re = \
494 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
495 _hash_fn = \<($(_hash_re)) *\(
496 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
497 sc_prohibit_hash_without_use:
498         @h='hash.h' \
499         re='$(_hash_fn)|$(_hash_struct)'\
500           $(_sc_header_without_use)
501
502 sc_prohibit_cloexec_without_use:
503         @h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
504           $(_sc_header_without_use)
505
506 sc_prohibit_posixver_without_use:
507         @h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)
508
509 sc_prohibit_same_without_use:
510         @h='same.h' re='\<same_name *\(' $(_sc_header_without_use)
511
512 sc_prohibit_hash_pjw_without_use:
513         @h='hash-pjw.h' \
514         re='\<hash_pjw *\(' \
515           $(_sc_header_without_use)
516
517 sc_prohibit_safe_read_without_use:
518         @h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
519           $(_sc_header_without_use)
520
521 sc_prohibit_argmatch_without_use:
522         @h='argmatch.h' \
523         re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
524           $(_sc_header_without_use)
525
526 sc_prohibit_canonicalize_without_use:
527         @h='canonicalize.h' \
528         re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
529           $(_sc_header_without_use)
530
531 sc_prohibit_root_dev_ino_without_use:
532         @h='root-dev-ino.h' \
533         re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
534           $(_sc_header_without_use)
535
536 sc_prohibit_openat_without_use:
537         @h='openat.h' \
538         re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
539           $(_sc_header_without_use)
540
541 # Prohibit the inclusion of c-ctype.h without an actual use.
542 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
543 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
544 sc_prohibit_c_ctype_without_use:
545         @h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
546           $(_sc_header_without_use)
547
548 _empty =
549 _sp = $(_empty) $(_empty)
550 # The following list was generated by running:
551 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
552 #   | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
553 _sig_functions = \
554   bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
555   sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
556   siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
557   sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
558 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
559 # The following were extracted from "man signal.h" manually.
560 _sig_types_and_consts =                                                 \
561   MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK           \
562   SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL            \
563   SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE    \
564   SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t  \
565   sigstack sigval stack_t ucontext_t
566 # generated via this:
567 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
568 _sig_names =                                                            \
569   SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT      \
570   SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL       \
571   SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP  \
572   SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR      \
573   SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS   \
574   SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1        \
575   SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW       \
576   SIGXCPU SIGXFSZ
577 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
578
579 # Prohibit the inclusion of signal.h without an actual use.
580 sc_prohibit_signal_without_use:
581         @h='signal.h'                                                   \
582         re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>'          \
583           $(_sc_header_without_use)
584
585 # Don't include stdio--.h unless you use one of its functions.
586 sc_prohibit_stdio--_without_use:
587         @h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\('              \
588           $(_sc_header_without_use)
589
590 # Don't include stdio-safer.h unless you use one of its functions.
591 sc_prohibit_stdio-safer_without_use:
592         @h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\('    \
593           $(_sc_header_without_use)
594
595 # Prohibit the inclusion of strings.h without a sensible use.
596 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
597 sc_prohibit_strings_without_use:
598         @h='strings.h'                                                  \
599         re='\<(strn?casecmp|ffs(ll)?)\>'                                \
600           $(_sc_header_without_use)
601
602 # Get the list of symbol names with this:
603 # perl -lne '/^# *define ([A-Z]\w+)\(/ and print $1' lib/intprops.h|fmt
604 _intprops_names =                                                       \
605   TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT             \
606   TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM           \
607   INT_BITS_STRLEN_BOUND INT_STRLEN_BOUND INT_BUFSIZE_BOUND              \
608   INT_ADD_RANGE_OVERFLOW INT_SUBTRACT_RANGE_OVERFLOW                    \
609   INT_NEGATE_RANGE_OVERFLOW INT_MULTIPLY_RANGE_OVERFLOW                 \
610   INT_DIVIDE_RANGE_OVERFLOW INT_REMAINDER_RANGE_OVERFLOW                \
611   INT_LEFT_SHIFT_RANGE_OVERFLOW INT_ADD_OVERFLOW INT_SUBTRACT_OVERFLOW  \
612   INT_NEGATE_OVERFLOW INT_MULTIPLY_OVERFLOW INT_DIVIDE_OVERFLOW         \
613   INT_REMAINDER_OVERFLOW INT_LEFT_SHIFT_OVERFLOW
614 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
615 # Prohibit the inclusion of intprops.h without an actual use.
616 sc_prohibit_intprops_without_use:
617         @h='intprops.h'                                                 \
618         re='\<($(_intprops_syms_re)) *\('                               \
619           $(_sc_header_without_use)
620
621 _stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
622 # Prohibit the inclusion of stddef.h without an actual use.
623 sc_prohibit_stddef_without_use:
624         @h='stddef.h'                                                   \
625         re='\<($(_stddef_syms_re))\>'                                   \
626           $(_sc_header_without_use)
627
628 # Prohibit the inclusion of verify.h without an actual use.
629 sc_prohibit_verify_without_use:
630         @h='verify.h'                                                   \
631         re='\<(verify(true|expr)?|static_assert) *\('                   \
632           $(_sc_header_without_use)
633
634 # Don't include xfreopen.h unless you use one of its functions.
635 sc_prohibit_xfreopen_without_use:
636         @h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)
637
638 sc_obsolete_symbols:
639         @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>'                     \
640         halt='do not use HAVE''_FCNTL_H or O'_NDELAY                    \
641           $(_sc_search_regexp)
642
643 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
644
645 # Each nonempty ChangeLog line must start with a year number, or a TAB.
646 sc_changelog:
647         @prohibit='^[^12        ]'                                      \
648         in_vc_files='^ChangeLog$$'                                      \
649         halt='found unexpected prefix in a ChangeLog'                   \
650           $(_sc_search_regexp)
651
652 # Ensure that each .c file containing a "main" function also
653 # calls set_program_name.
654 sc_program_name:
655         @require='set_program_name *\(m?argv\[0\]\);'                   \
656         in_vc_files='\.c$$'                                             \
657         containing='\<main *('                                          \
658         halt='the above files do not call set_program_name'             \
659           $(_sc_search_regexp)
660
661 # Ensure that each .c file containing a "main" function also
662 # calls bindtextdomain.
663 sc_bindtextdomain:
664         @require='bindtextdomain *\('                                   \
665         in_vc_files='\.c$$'                                             \
666         containing='\<main *('                                          \
667         halt='the above files do not call bindtextdomain'               \
668           $(_sc_search_regexp)
669
670 # Require that the final line of each test-lib.sh-using test be this one:
671 # Exit $fail
672 # Note: this test requires GNU grep's --label= option.
673 Exit_witness_file ?= tests/test-lib.sh
674 Exit_base := $(notdir $(Exit_witness_file))
675 sc_require_test_exit_idiom:
676         @if test -f $(srcdir)/$(Exit_witness_file); then                \
677           die=0;                                                        \
678           for i in $$(grep -l -F 'srcdir/$(Exit_base)'                  \
679                 $$($(VC_LIST) tests)); do                               \
680             tail -n1 $$i | grep '^Exit .' > /dev/null                   \
681               && : || { die=1; echo $$i; }                              \
682           done;                                                         \
683           test $$die = 1 &&                                             \
684             { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
685               echo 1>&2 'Exit something';                               \
686               exit 1; } || :;                                           \
687         fi
688
689 sc_trailing_blank:
690         @prohibit='[     ]$$'                                           \
691         halt='found trailing blank(s)'                                  \
692           $(_sc_search_regexp)
693
694 # Match lines like the following, but where there is only one space
695 # between the options and the description:
696 #   -D, --all-repeated[=delimit-method]  print all duplicate lines\n
697 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
698 sc_two_space_separator_in_usage:
699         @prohibit='^   *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$'         \
700         halt='help2man requires at least two spaces between an option and its description'\
701           $(_sc_search_regexp)
702
703 # A regexp matching function names like "error" that may be used
704 # to emit translatable messages.
705 _gl_translatable_diag_func_re ?= error
706
707 # Look for diagnostics that aren't marked for translation.
708 # This won't find any for which error's format string is on a separate line.
709 sc_unmarked_diagnostics:
710         @grep -nE                                                       \
711             '\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
712                 $$($(VC_LIST_EXCEPT))                                   \
713           | grep -Ev '(_|ngettext ?)\(' &&                              \
714           { echo '$(ME): found unmarked diagnostic(s)' 1>&2;            \
715             exit 1; } || :
716
717 # Avoid useless parentheses like those in this example:
718 # #if defined (SYMBOL) || defined (SYM2)
719 sc_useless_cpp_parens:
720         @prohibit='^# *if .*defined *\('                                \
721         halt='found useless parentheses in cpp directive'               \
722           $(_sc_search_regexp)
723
724 # List headers for which HAVE_HEADER_H is always true, assuming you are
725 # using the appropriate gnulib module.  CAUTION: for each "unnecessary"
726 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
727 # requires the gnulib module that guarantees the usability of that header.
728 gl_assured_headers_ = \
729   cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
730
731 # Convert the list of names to upper case, and replace each space with "|".
732 az_ = abcdefghijklmnopqrstuvwxyz
733 AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
734 gl_header_upper_case_or_ =                                              \
735   $$($(gl_assured_headers_)                                             \
736     | tr $(az_)/.- $(AZ_)___                                            \
737     | tr -s ' ' '|'                                                     \
738     )
739 sc_prohibit_always_true_header_tests:
740         @or=$(gl_header_upper_case_or_);                                \
741         re="HAVE_($$or)_H";                                             \
742         prohibit='\<'"$$re"'\>'                                         \
743         halt=$$(printf '%s\n'                                           \
744         'do not test the above HAVE_<header>_H symbol(s);'              \
745         '  with the corresponding gnulib module, they are always true') \
746           $(_sc_search_regexp)
747
748 # ==================================================================
749 gl_other_headers_ ?= \
750   intprops.h    \
751   openat.h      \
752   stat-macros.h
753
754 # Perl -lne code to extract "significant" cpp-defined symbols from a
755 # gnulib header file, eliminating a few common false-positives.
756 # The exempted names below are defined only conditionally in gnulib,
757 # and hence sometimes must/may be defined in application code.
758 gl_extract_significant_defines_ = \
759   /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
760     && $$2 !~ /(?:rpl_|_used_without_)/\
761     && $$1 !~ /^(?:NSIG|ENODATA)$$/\
762     && $$1 !~ /^(?:SA_RESETHAND|SA_RESTART)$$/\
763     and print $$1
764
765 # Create a list of regular expressions matching the names
766 # of macros that are guaranteed to be defined by parts of gnulib.
767 define def_sym_regex
768         gen_h=$(gl_generated_headers_);                                 \
769         (cd $(gnulib_dir)/lib;                                          \
770           for f in *.in.h $(gl_other_headers_); do                      \
771             test -f $$f                                                 \
772               && perl -lne '$(gl_extract_significant_defines_)' $$f;    \
773           done;                                                         \
774         ) | sort -u                                                     \
775           | sed 's/^/^ *# *(define|undef)  */;s/$$/\\>/'
776 endef
777
778 # Don't define macros that we already get from gnulib header files.
779 sc_prohibit_always-defined_macros:
780         @if test -d $(gnulib_dir); then                                 \
781           case $$(echo all: | grep -l -f - Makefile) in Makefile);; *)  \
782             echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
783           esac;                                                         \
784           $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT))         \
785             && { echo '$(ME): define the above via some gnulib .h file' \
786                   1>&2;  exit 1; } || :;                                \
787         fi
788 # ==================================================================
789
790 # Prohibit checked in backup files.
791 sc_prohibit_backup_files:
792         @$(VC_LIST) | grep '~$$' &&                             \
793           { echo '$(ME): found version controlled backup file' 1>&2;    \
794             exit 1; } || :
795
796 # Require the latest GPL.
797 sc_GPL_version:
798         @prohibit='either ''version [^3]'                               \
799         halt='GPL vN, N!=3'                                             \
800           $(_sc_search_regexp)
801
802 # Require the latest GFDL.  Two regexp, since some .texi files end up
803 # line wrapping between 'Free Documentation License,' and 'Version'.
804 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
805 sc_GFDL_version:
806         @prohibit='$(_GFDL_regexp)'                                     \
807         halt='GFDL vN, N!=3'                                            \
808           $(_sc_search_regexp)
809
810 # Don't use Texinfo's @acronym{}.
811 # http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
812 texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
813 sc_texinfo_acronym:
814         @prohibit='@acronym\{'                                          \
815         in_vc_files='$(texinfo_suffix_re_)'                             \
816         halt='found use of Texinfo @acronym{}'                          \
817           $(_sc_search_regexp)
818
819 cvs_keywords = \
820   Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
821
822 sc_prohibit_cvs_keyword:
823         @prohibit='\$$($(cvs_keywords))\$$'                             \
824         halt='do not use CVS keyword expansion'                         \
825           $(_sc_search_regexp)
826
827 # This Perl code is slightly obfuscated.  Not only is each "$" doubled
828 # because it's in a Makefile, but the $$c's are comments;  we cannot
829 # use "#" due to the way the script ends up concatenated onto one line.
830 # It would be much more concise, and would produce better output (including
831 # counts) if written as:
832 #   perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
833 # but that would be far less efficient, reading the entire contents
834 # of each file, rather than just the last two bytes of each.
835 # In addition, while the code below detects both blank lines and a missing
836 # newline at EOF, the above detects only the former.
837 #
838 # This is a perl script that is expected to be the single-quoted argument
839 # to a command-line "-le".  The remaining arguments are file names.
840 # Print the name of each file that ends in exactly one newline byte.
841 # I.e., warn if there are blank lines (2 or more newlines), or if the
842 # last byte is not a newline.  However, currently we don't complain
843 # about any file that contains exactly one byte.
844 # Exit nonzero if at least one such file is found, otherwise, exit 0.
845 # Warn about, but otherwise ignore open failure.  Ignore seek/read failure.
846 #
847 # Use this if you want to remove trailing empty lines from selected files:
848 #   perl -pi -0777 -e 's/\n\n+$/\n/' files...
849 #
850 require_exactly_one_NL_at_EOF_ =                                        \
851   foreach my $$f (@ARGV)                                                \
852     {                                                                   \
853       open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next;     \
854       my $$p = sysseek (F, -2, 2);                                      \
855       my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
856       my $$last_two_bytes;                                              \
857       defined $$p and $$p = sysread F, $$last_two_bytes, 2;             \
858       close F;                                                          \
859       $$c = "ignore read failure";                                      \
860       $$p && ($$last_two_bytes eq "\n\n"                                \
861               || substr ($$last_two_bytes,1) ne "\n")                   \
862           and (print $$f), $$fail=1;                                    \
863     }                                                                   \
864   END { exit defined $$fail }
865 sc_prohibit_empty_lines_at_EOF:
866         @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
867           || { echo '$(ME): empty line(s) or no newline at EOF'         \
868                 1>&2; exit 1; } || :
869
870 # Make sure we don't use st_blocks.  Use ST_NBLOCKS instead.
871 # This is a bit of a kludge, since it prevents use of the string
872 # even in comments, but for now it does the job with no false positives.
873 sc_prohibit_stat_st_blocks:
874         @prohibit='[.>]st_blocks'                                       \
875         halt='do not use st_blocks; use ST_NBLOCKS'                     \
876           $(_sc_search_regexp)
877
878 # Make sure we don't define any S_IS* macros in src/*.c files.
879 # They're already defined via gnulib's sys/stat.h replacement.
880 sc_prohibit_S_IS_definition:
881         @prohibit='^ *# *define  *S_IS'                                 \
882         halt='do not define S_IS* macros; include <sys/stat.h>'         \
883           $(_sc_search_regexp)
884
885 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
886 # that is shared by two definitions below.
887 perl_filename_lineno_text_ =                                            \
888     -e '  {'                                                            \
889     -e '    $$n = ($$` =~ tr/\n/\n/ + 1);'                              \
890     -e '    ($$v = $$&) =~ s/\n/\\n/g;'                                 \
891     -e '    print "$$ARGV:$$n:$$v\n";'                                  \
892     -e '  }'
893
894 prohibit_doubled_word_RE_ ?= \
895   /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
896 prohibit_doubled_word_ =                                                \
897     -e 'while ($(prohibit_doubled_word_RE_))'                           \
898     $(perl_filename_lineno_text_)
899
900 # Define this to a regular expression that matches
901 # any filename:dd:match lines you want to ignore.
902 # The default is to ignore no matches.
903 ignore_doubled_word_match_RE_ ?= ^$$
904
905 sc_prohibit_doubled_word:
906         @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT))  \
907           | grep -vE '$(ignore_doubled_word_match_RE_)'                 \
908           | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
909
910 # A regular expression matching undesirable combinations of words like
911 # "can not"; this matches them even when the two words appear on different
912 # lines, but not when there is an intervening delimiter like "#" or "*".
913 prohibit_undesirable_word_seq_RE_ ?=                                    \
914   /\bcan\s+not\b/gims
915 prohibit_undesirable_word_seq_ =                                        \
916     -e 'while ($(prohibit_undesirable_word_seq_RE_))'                   \
917     $(perl_filename_lineno_text_)
918 # Define this to a regular expression that matches
919 # any filename:dd:match lines you want to ignore.
920 # The default is to ignore no matches.
921 ignore_undesirable_word_sequence_RE_ ?= ^$$
922
923 sc_prohibit_undesirable_word_seq:
924         @perl -n -0777 $(prohibit_undesirable_word_seq_)                \
925              $$($(VC_LIST_EXCEPT))                                      \
926           | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
927           && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
928
929 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
930 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
931 # Using test's -a and -o operators is not portable.
932 # We prefer test over [, since the latter is spelled [[ in configure.ac.
933 sc_prohibit_test_minus_ao:
934         @prohibit='(\<test| \[+) .+ -[ao] '                             \
935         halt='$(_ptm1); $(_ptm2)'                                       \
936           $(_sc_search_regexp)
937
938 # Avoid a test bashism.
939 sc_prohibit_test_double_equal:
940         @prohibit='(\<test| \[+) .+ == '                                \
941         containing='#! */bin/[a-z]*sh'                                  \
942         halt='use "test x = x", not "test x =''= x"'                    \
943           $(_sc_search_regexp)
944
945 # Each program that uses proper_name_utf8 must link with one of the
946 # ICONV libraries.  Otherwise, some ICONV library must appear in LDADD.
947 # The perl -0777 invocation below extracts the possibly-multi-line
948 # definition of LDADD from the appropriate Makefile.am and exits 0
949 # when it contains "ICONV".
950 sc_proper_name_utf8_requires_ICONV:
951         @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
952         if test "x$$progs" != x; then                                   \
953           fail=0;                                                       \
954           for p in $$progs; do                                          \
955             dir=$$(dirname "$$p");                                      \
956             perl -0777                                                  \
957               -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)'  \
958               $$dir/Makefile.am && continue;                            \
959             base=$$(basename "$$p" .c);                                 \
960             grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
961               || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
962           done;                                                         \
963           test $$fail = 1 &&                                            \
964             { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
965               exit 1; } || :;                                           \
966         fi
967
968 # Warn about "c0nst struct Foo const foo[]",
969 # but not about "char const *const foo" or "#define const const".
970 sc_redundant_const:
971         @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b'          \
972         halt='redundant "const" in declarations'                        \
973           $(_sc_search_regexp)
974
975 sc_const_long_option:
976         @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT))         \
977           | grep -Ev 'const struct option|struct option const' && {     \
978               echo 1>&2 '$(ME): add "const" to the above declarations'; \
979               exit 1; } || :
980
981 NEWS_hash =                                                             \
982   $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p'              \
983        $(srcdir)/NEWS                                                   \
984      | perl -0777 -pe                                                   \
985         's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms'       \
986      | md5sum -                                                         \
987      | sed 's/ .*//')
988
989 # Ensure that we don't accidentally insert an entry into an old NEWS block.
990 sc_immutable_NEWS:
991         @if test -f $(srcdir)/NEWS; then                                \
992           test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : ||              \
993             { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
994         fi
995
996 # Update the hash stored above.  Do this after each release and
997 # for any corrections to old entries.
998 update-NEWS-hash: NEWS
999         perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1000           $(srcdir)/cfg.mk
1001
1002 # Ensure that we use only the standard $(VAR) notation,
1003 # not @...@ in Makefile.am, now that we can rely on automake
1004 # to emit a definition for each substituted variable.
1005 # However, there is still one case in which @VAR@ use is not just
1006 # legitimate, but actually required: when augmenting an automake-defined
1007 # variable with a prefix.  For example, gettext uses this:
1008 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1009 # otherwise, makeinfo would put German or French (current locale)
1010 # navigation hints in the otherwise-English documentation.
1011 #
1012 # Allow the package to add exceptions via a hook in cfg.mk;
1013 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1014 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1015 _makefile_at_at_check_exceptions ?=
1016 sc_makefile_at_at_check:
1017         @perl -ne '/\@[A-Z_0-9]+\@/'                                    \
1018           -e ' && !/([A-Z_0-9]+)\s+=.*\@\1\@$$/'                        \
1019           -e ''$(_makefile_at_at_check_exceptions)                      \
1020           -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}'    \
1021             $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1022           && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1023
1024 news-check: NEWS
1025         if sed -n $(news-check-lines-spec)p $(srcdir)/NEWS              \
1026             | grep -E $(news-check-regexp) >/dev/null; then             \
1027           :;                                                            \
1028         else                                                            \
1029           echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2;      \
1030           exit 1;                                                       \
1031         fi
1032
1033 sc_makefile_TAB_only_indentation:
1034         @prohibit='^    [ ]{8}'                                         \
1035         in_vc_files='akefile|\.mk$$'                                    \
1036         halt='found TAB-8-space indentation'                            \
1037           $(_sc_search_regexp)
1038
1039 sc_m4_quote_check:
1040         @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]'              \
1041         in_vc_files='(^configure\.ac|\.m4)$$'                           \
1042         halt='quote the first arg to AC_DEF*'                           \
1043           $(_sc_search_regexp)
1044
1045 fix_po_file_diag = \
1046 'you have changed the set of files with translatable diagnostics;\n\
1047 apply the above patch\n'
1048
1049 # Verify that all source files using _() are listed in po/POTFILES.in.
1050 po_file ?= $(srcdir)/po/POTFILES.in
1051 generated_files ?= $(srcdir)/lib/*.[ch]
1052 sc_po_check:
1053         @if test -f $(po_file); then                                    \
1054           grep -E -v '^(#|$$)' $(po_file)                               \
1055             | grep -v '^src/false\.c$$' | sort > $@-1;                  \
1056           files=;                                                       \
1057           for file in $$($(VC_LIST_EXCEPT)) $(generated_files); do      \
1058             test -r $$file || continue;                                 \
1059             case $$file in                                              \
1060               *.m4|*.mk) continue ;;                                    \
1061               *.?|*.??) ;;                                              \
1062               *) continue;;                                             \
1063             esac;                                                       \
1064             case $$file in                                              \
1065             *.[ch])                                                     \
1066               base=`expr " $$file" : ' \(.*\)\..'`;                     \
1067               { test -f $$base.l || test -f $$base.y; } && continue;;   \
1068             esac;                                                       \
1069             files="$$files $$file";                                     \
1070           done;                                                         \
1071           grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files          \
1072             | sed 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2;      \
1073           diff -u -L $(po_file) -L $(po_file) $@-1 $@-2                 \
1074             || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; };   \
1075           rm -f $@-1 $@-2;                                              \
1076         fi
1077
1078 # Sometimes it is useful to change the PATH environment variable
1079 # in Makefiles.  When doing so, it's better not to use the Unix-centric
1080 # path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
1081 msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
1082 sc_makefile_path_separator_check:
1083         @prohibit='PATH[=].*:'                                          \
1084         in_vc_files='akefile|\.mk$$'                                    \
1085         halt=$(msg)                                                     \
1086           $(_sc_search_regexp)
1087
1088 # Check that `make alpha' will not fail at the end of the process,
1089 # i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1090 # and is read-only.
1091 writable-files:
1092         if test -d $(release_archive_dir); then                         \
1093           for file in $(DIST_ARCHIVES); do                              \
1094             for p in ./ $(release_archive_dir)/; do                     \
1095               test -e $$p$$file || continue;                            \
1096               test -w $$p$$file                                         \
1097                 || { echo ERROR: $$p$$file is not writable; fail=1; };  \
1098             done;                                                       \
1099           done;                                                         \
1100           test "$$fail" && exit 1 || : ;                                \
1101         else :;                                                         \
1102         fi
1103
1104 v_etc_file = $(gnulib_dir)/lib/version-etc.c
1105 sample-test = tests/sample-test
1106 texi = doc/$(PACKAGE).texi
1107 # Make sure that the copyright date in $(v_etc_file) is up to date.
1108 # Do the same for the $(sample-test) and the main doc/.texi file.
1109 sc_copyright_check:
1110         @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };'            \
1111         in_files=$(v_etc_file)                                          \
1112         halt='out of date copyright in $(v_etc_file); update it'        \
1113           $(_sc_search_regexp)
1114         @require='# Copyright \(C\) '$$(date +%Y)' Free'                \
1115         in_vc_files=$(sample-test)                                      \
1116         halt='out of date copyright in $(sample-test); update it'       \
1117           $(_sc_search_regexp)
1118         @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free'       \
1119         in_vc_files=$(texi)                                             \
1120         halt='out of date copyright in $(texi); update it'              \
1121           $(_sc_search_regexp)
1122
1123 # If tests/help-version exists and seems to be new enough, assume that its
1124 # use of init.sh and path_prepend_ is correct, and ensure that every other
1125 # use of init.sh is identical.
1126 # This is useful because help-version cross-checks prog --version
1127 # with $(VERSION), which verifies that its path_prepend_ invocation
1128 # sets PATH correctly.  This is an inexpensive way to ensure that
1129 # the other init.sh-using tests also get it right.
1130 _hv_file ?= $(srcdir)/tests/help-version
1131 _hv_regex_weak ?= ^ *\. .*/init\.sh"
1132 # Fix syntax-highlighters "
1133 _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1134 sc_cross_check_PATH_usage_in_tests:
1135         @if test -f $(_hv_file); then                                   \
1136           grep -l 'VERSION mismatch' $(_hv_file) >/dev/null             \
1137             || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2;    \
1138                  exit 0; };                                             \
1139           grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null         \
1140             || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1141                  exit 1; };                                             \
1142           good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file));           \
1143           grep -LFx "$$good"                                            \
1144                 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT)))  \
1145               | grep . &&                                               \
1146             { echo "$(ME): the above files use path_prepend_ inconsistently" \
1147                 1>&2; exit 1; } || :;                                   \
1148         fi
1149
1150 # #if HAVE_... will evaluate to false for any non numeric string.
1151 # That would be flagged by using -Wundef, however gnulib currently
1152 # tests many undefined macros, and so we can't enable that option.
1153 # So at least preclude common boolean strings as macro values.
1154 sc_Wundef_boolean:
1155         @prohibit='^#define.*(yes|no|true|false)$$'                     \
1156         in_files='$(CONFIG_INCLUDE)'                                    \
1157         halt='Use 0 or 1 for macro values'                              \
1158           $(_sc_search_regexp)
1159
1160 # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1161 # not be constant, or might overflow a stack.  In general, use PATH_MAX as
1162 # a limit, not an array or alloca size.
1163 sc_prohibit_path_max_allocation:
1164         @prohibit='(\balloca *\([^)]*|\[[^]]*)PATH_MAX'                 \
1165         halt='Avoid stack allocations of size PATH_MAX'                 \
1166           $(_sc_search_regexp)
1167
1168 sc_vulnerable_makefile_CVE-2009-4029:
1169         @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1170         in_files=$$(find $(srcdir) -name Makefile.in)                   \
1171         halt=$$(printf '%s\n'                                           \
1172           'the above files are vulnerable; beware of running'           \
1173           '  "make dist*" rules, and upgrade to fixed automake'         \
1174           '  see http://bugzilla.redhat.com/542609 for details')        \
1175           $(_sc_search_regexp)
1176
1177 vc-diff-check:
1178         (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1179         if test -s vc-diffs; then                               \
1180           cat vc-diffs;                                         \
1181           echo "Some files are locally modified:" 1>&2;         \
1182           exit 1;                                               \
1183         else                                                    \
1184           rm vc-diffs;                                          \
1185         fi
1186
1187 rel-files = $(DIST_ARCHIVES)
1188
1189 gnulib_dir ?= $(srcdir)/gnulib
1190 gnulib-version = $$(cd $(gnulib_dir) && git describe)
1191 bootstrap-tools ?= autoconf,automake,gnulib
1192
1193 # If it's not already specified, derive the GPG key ID from
1194 # the signed tag we've just applied to mark this release.
1195 gpg_key_ID ?= \
1196   $$(git cat-file tag v$(VERSION) > .ann-sig \
1197      && gpgv .ann-sig - < /dev/null 2>&1 \
1198           | sed -n '/.*key ID \([0-9A-F]*\)/s//\1/p'; rm -f .ann-sig)
1199
1200 translation_project_ ?= coordinator@translationproject.org
1201
1202 # Make info-gnu the default only for a stable release.
1203 ifeq ($(RELEASE_TYPE),stable)
1204   announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1205   announcement_mail_headers_ ?=                                         \
1206     To: info-gnu@gnu.org                                                \
1207     Cc: $(announcement_Cc_)                                             \
1208     Mail-Followup-To: $(PACKAGE_BUGREPORT)
1209 else
1210   announcement_Cc_ ?= $(translation_project_)
1211   announcement_mail_headers_ ?=                                         \
1212     To: $(PACKAGE_BUGREPORT)                                            \
1213     Cc: $(announcement_Cc_)
1214 endif
1215
1216 announcement: NEWS ChangeLog $(rel-files)
1217         @$(srcdir)/$(_build-aux)/announce-gen                           \
1218             --mail-headers='$(announcement_mail_headers_)'              \
1219             --release-type=$(RELEASE_TYPE)                              \
1220             --package=$(PACKAGE)                                        \
1221             --prev=$(PREV_VERSION)                                      \
1222             --curr=$(VERSION)                                           \
1223             --gpg-key-id=$(gpg_key_ID)                                  \
1224             --news=$(srcdir)/NEWS                                       \
1225             --bootstrap-tools=$(bootstrap-tools)                        \
1226             --gnulib-version=$(gnulib-version)                          \
1227             --no-print-checksums                                        \
1228             $(addprefix --url-dir=, $(url_dir_list))
1229
1230 ## ---------------- ##
1231 ## Updating files.  ##
1232 ## ---------------- ##
1233
1234 ftp-gnu = ftp://ftp.gnu.org/gnu
1235 www-gnu = http://www.gnu.org
1236
1237 upload_dest_dir_ ?= $(PACKAGE)
1238 emit_upload_commands:
1239         @echo =====================================
1240         @echo =====================================
1241         @echo "$(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \\"
1242         @echo "    --to $(gnu_rel_host):$(upload_dest_dir_) \\"
1243         @echo "  $(rel-files)"
1244         @echo '# send the ~/announce-$(my_distdir) e-mail'
1245         @echo =====================================
1246         @echo =====================================
1247
1248 define emit-commit-log
1249   printf '%s\n' 'maint: post-release administrivia' ''                  \
1250     '* NEWS: Add header line for next release.'                         \
1251     '* .prev-version: Record previous version.'                         \
1252     '* cfg.mk (old_NEWS_hash): Auto-update.'
1253 endef
1254
1255 .PHONY: no-submodule-changes
1256 no-submodule-changes:
1257         if test -d $(srcdir)/.git; then                                 \
1258           diff=$$(cd $(srcdir) && git submodule -q foreach              \
1259                   git diff-index --name-only HEAD)                      \
1260             || exit 1;                                                  \
1261           case $$diff in '') ;;                                         \
1262             *) echo '$(ME): submodule files are locally modified:';     \
1263                 echo "$$diff"; exit 1;; esac;                           \
1264         else                                                            \
1265           : ;                                                           \
1266         fi
1267
1268 submodule-checks ?= no-submodule-changes public-submodule-commit
1269
1270 # Ensure that each sub-module commit we're using is public.
1271 # Without this, it is too easy to tag and release code that
1272 # cannot be built from a fresh clone.
1273 .PHONY: public-submodule-commit
1274 public-submodule-commit:
1275         $(AM_V_GEN)if test -d $(srcdir)/.git; then                      \
1276           cd $(srcdir) &&                                               \
1277           git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
1278               = '$$(git merge-base origin $$sha1)'                      \
1279             || { echo '$(ME): found non-public submodule commit' >&2;   \
1280                  exit 1; };                                             \
1281         else                                                            \
1282           : ;                                                           \
1283         fi
1284 # This rule has a high enough utility/cost ratio that it should be a
1285 # dependent of "check" by default.  However, some of us do occasionally
1286 # commit a temporary change that deliberately points to a non-public
1287 # submodule commit, and want to be able to use rules like "make check".
1288 # In that case, run e.g., "make check gl_public_submodule_commit="
1289 # to disable this test.
1290 gl_public_submodule_commit ?= public-submodule-commit
1291 check: $(gl_public_submodule_commit)
1292
1293 .PHONY: alpha beta stable
1294 ALL_RECURSIVE_TARGETS += alpha beta stable
1295 alpha beta stable: $(local-check) writable-files $(submodule-checks)
1296         test $@ = stable                                                \
1297           && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$'         \
1298                || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1299           || :
1300         $(MAKE) vc-diff-check
1301         $(MAKE) news-check
1302         $(MAKE) distcheck
1303         $(MAKE) dist XZ_OPT=-9ev
1304         $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1305         $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1306
1307 # Override this in cfg.mk if you follow different procedures.
1308 release-prep-hook ?= release-prep
1309
1310 gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1311 .PHONY: release-prep
1312 release-prep:
1313         case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1314           *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
1315         $(MAKE) --no-print-directory -s announcement > ~/announce-$(my_distdir)
1316         if test -d $(release_archive_dir); then                 \
1317           ln $(rel-files) $(release_archive_dir);               \
1318           chmod a-w $(rel-files);                               \
1319         fi
1320         echo $(VERSION) > $(prev_version_file)
1321         $(MAKE) update-NEWS-hash
1322         perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' NEWS
1323         $(emit-commit-log) > .ci-msg
1324         $(VC) commit -F .ci-msg -a
1325         rm .ci-msg
1326
1327 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1328 # if the default $(PACKAGE)-derived name doesn't apply.
1329 gendocs_options_ ?=
1330
1331 .PHONY: web-manual
1332 web-manual:
1333         @test -z "$(manual_title)" \
1334           && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1335         @cd '$(srcdir)/doc'; \
1336           $(SHELL) ../$(_build-aux)/gendocs.sh $(gendocs_options_) \
1337              -o '$(abs_builddir)/doc/manual' \
1338              --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1339             "$(PACKAGE_NAME) - $(manual_title)"
1340         @echo " *** Upload the doc/manual directory to web-cvs."
1341
1342 # Code Coverage
1343
1344 init-coverage:
1345         $(MAKE) $(AM_MAKEFLAGS) clean
1346         lcov --directory . --zerocounters
1347
1348 COVERAGE_CCOPTS ?= "-g --coverage"
1349 COVERAGE_OUT ?= doc/coverage
1350
1351 build-coverage:
1352         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1353         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1354         mkdir -p $(COVERAGE_OUT)
1355         lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1356                 --capture
1357
1358 gen-coverage:
1359         genhtml --output-directory $(COVERAGE_OUT) \
1360                 $(COVERAGE_OUT)/$(PACKAGE).info \
1361                 --highlight --frames --legend \
1362                 --title "$(PACKAGE_NAME)"
1363
1364 coverage: init-coverage build-coverage gen-coverage
1365
1366 # Update gettext files.
1367 PACKAGE ?= $(shell basename $(PWD))
1368 PO_DOMAIN ?= $(PACKAGE)
1369 POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1370 PODIR ?= po
1371 refresh-po:
1372         rm -f $(PODIR)/*.po && \
1373         echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1374         wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1375         echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1376         echo 'en@quot' >> $(PODIR)/LINGUAS && \
1377         ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1378
1379  # Running indent once is not idempotent, but running it twice is.
1380 INDENT_SOURCES ?= $(C_SOURCES)
1381 .PHONY: indent
1382 indent:
1383         indent $(INDENT_SOURCES)
1384         indent $(INDENT_SOURCES)
1385
1386 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1387 # put the assignments in this variable.
1388 update-copyright-env ?=
1389
1390 # Run this rule once per year (usually early in January)
1391 # to update all FSF copyright year lists in your project.
1392 # If you have an additional project-specific rule,
1393 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1394 # By default, exclude all variants of COPYING; you can also
1395 # add exemptions (such as ChangeLog..* for rotated change logs)
1396 # in the file .x-update-copyright.
1397 .PHONY: update-copyright
1398 update-copyright:
1399         grep -l -w Copyright                                             \
1400           $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1401           | $(update-copyright-env) xargs $(srcdir)/$(_build-aux)/$@
1402
1403 # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1404 # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1405
1406 # NOTE: to override any _gl_TS_* default value, you must
1407 # define the variable(s) using "export" in cfg.mk.
1408 _gl_TS_dir ?= src
1409
1410 ALL_RECURSIVE_TARGETS += sc_tight_scope
1411 sc_tight_scope: tight-scope.mk
1412         @fail=0;                                                        \
1413         if ! grep '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk        \
1414                 > /dev/null                                             \
1415            && ! grep -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1416                 > /dev/null 2>&1; then                                  \
1417             echo '$(ME): skipping $@';                                  \
1418         else                                                            \
1419             $(MAKE) -s -C $(_gl_TS_dir)                                 \
1420                 -f Makefile                                             \
1421                 -f $(abs_top_srcdir)/cfg.mk                             \
1422                 -f $(abs_top_builddir)/$<                               \
1423               _gl_tight_scope                                           \
1424                 || fail=1;                                              \
1425         fi;                                                             \
1426         rm -f $<;                                                       \
1427         exit $$fail
1428
1429 tight-scope.mk: $(ME)
1430         @rm -f $@ $@-t
1431         @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(ME) > $@-t
1432         @chmod a=r $@-t && mv $@-t $@
1433
1434 ifeq (a,b)
1435 # TS-start
1436
1437 # Most functions should have static scope.
1438 # Any that don't must be marked with `extern', but `main'
1439 # and `usage' are exceptions: they're always extern, but
1440 # do not need to be marked.  Symbols matching `__.*' are
1441 # reserved by the compiler, so are automatically excluded below.
1442 _gl_TS_unmarked_extern_functions ?= main usage
1443 _gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\S+) *\(/
1444
1445 # If your project uses a macro like "XTERN", then put
1446 # the following in cfg.mk to override this default:
1447 # export _gl_TS_extern = extern|XTERN
1448 _gl_TS_extern ?= extern
1449
1450 # The second nm|grep checks for file-scope variables with `extern' scope.
1451 # Without gnulib's progname module, you might put program_name here.
1452 # Symbols matching `__.*' are reserved by the compiler,
1453 # so are automatically excluded below.
1454 _gl_TS_unmarked_extern_vars ?=
1455
1456 # NOTE: the _match variables are perl expressions -- not mere regular
1457 # expressions -- so that you can extend them to match other patterns
1458 # and easily extract matched variable names.
1459 # For example, if your project declares some global variables via
1460 # a macro like this: GLOBAL(type, var_name, initializer), then you
1461 # can override this definition to automatically extract those names:
1462 # export _gl_TS_var_match = \
1463 #   /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1464 _gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
1465
1466 # The names of object files in (or relative to) $(_gl_TS_dir).
1467 _gl_TS_obj_files ?= *.$(OBJEXT)
1468
1469 # Files in which to search for the one-line style extern declarations.
1470 # $(_gl_TS_dir)-relative.
1471 _gl_TS_headers ?= $(noinst_HEADERS)
1472
1473 .PHONY: _gl_tight_scope
1474 _gl_tight_scope: $(bin_PROGRAMS)
1475         t=exceptions-$$$$;                                              \
1476         trap 's=$$?; rm -f $$t; exit $$s' 0;                            \
1477         for sig in 1 2 3 13 15; do                                      \
1478           eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1479         done;                                                           \
1480         src=`for f in $(SOURCES); do                                    \
1481                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1482         hdr=`for f in $(_gl_TS_headers); do                             \
1483                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1484         ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions);  \
1485           grep -h -A1 '^extern .*[^;]$$' $$src                          \
1486             | grep -vE '^(extern |--)' | sed 's/ .*//';                 \
1487           perl -lne                                                     \
1488              '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr;      \
1489         ) | sort -u > $$t;                                              \
1490         nm -e $(_gl_TS_obj_files) | sed -n 's/.* T //p'|grep -Ev -f $$t \
1491           && { echo the above functions should have static scope >&2;   \
1492                exit 1; } || : ;                                         \
1493         ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars);       \
1494           perl -lne '$(_gl_TS_var_match) and print "^$$1\$$"' $$hdr *.h \
1495         ) | sort -u > $$t;                                              \
1496         nm -e $(_gl_TS_obj_files) | sed -n 's/.* [BCDGRS] //p'          \
1497             | sort -u | grep -Ev -f $$t                                 \
1498           && { echo the above variables should have static scope >&2;   \
1499                exit 1; } || :
1500 # TS-end
1501 endif